import type { NextPage } from "next";
import Head from "next/head";
import { useCallback, useEffect } from "react";
import { useDispatch, useSelector } from "react-redux";

import { getUserData } from "core/redux/actions/user";
import styles from "styles/pages/AuthPage.module.scss";
import Button from "core/uikit/Button";
import { IRootReducer } from "core/redux/reducers";
import authTokenService from "core/services/authTokenService";
import redirectTo from "core/utils/redirectTo";
import { IUserData } from "core/redux/reducers/user";

const Home: NextPage = () => {
  const dispatch = useDispatch();
  const userData = useSelector<IRootReducer, IUserData | undefined>((store) => store.user.userData);

  const handleGoToSite = useCallback(()=>{
    redirectTo('/panel/home');
  }, [])

  const handleUnauth = useCallback(()=>{
    authTokenService.clearRefreshData();
    authTokenService.clearToken();
    redirectTo('/auth');
  }, [])

  useEffect(()=>{
    if(!authTokenService.hasTokenInLocalstorage()) {
      redirectTo('/auth');
    }
    dispatch(getUserData());
  }, [dispatch])

  return (
    <div className={styles.page}>
      <Head>
        <title>Create Next App</title>
        <meta name="description" content="Generated by create next app" />
        <link rel="icon" href="/favicon.ico" />
      </Head>
      <main className={styles.main}>
        <div className={styles.authCard}>
          <span className={styles.authCard__brand}>MD.Cafe</span>

          <div className={styles.authCard__content}>
            <h1 className={styles.authCard__title}>
              {userData?.first_name}
            </h1>
            <h2 className={styles.authCard__subtitle}>Привет! Рады видеть тебя снова</h2>
            <hr />
            <div className={styles.authForm}>
              <Button
                theme='primary'
                size='md'
                onClick={handleGoToSite}
              >
                Перейти на сайт
              </Button>
              <Button
                theme='primary'
                variant='outline'
                size='md'
                onClick={handleUnauth}
              >
                Выйти из аккаунта
              </Button>
            </div>
          </div>

          <span className={styles.authCard__copy}>Powered by <a>M.Dev Group</a></span>
        </div>
      </main>
    </div>
  );
};

export default Home;
